package salomeTMF_plug.pluginxlsxml.Commun;

import java.io.IOException;
// -- TBT 2008-03-17
//import java.net.HttpURLConnection;
//import java.net.MalformedURLException;
// TBT 2008-03-17 --
import java.net.SocketTimeoutException;
import java.net.URL;
// ++ TBT 2008-03-17
import java.net.URLConnection;
//TBT 2008-03-17 ++

import org.objectweb.salome_tmf.ihm.main.SalomeTMFContext;

// -- TBT 2008-03-17
//import sun.net.www.protocol.file.FileURLConnection;
// TBT 2008-03-17 --

/**
 * Fonction permettant de tester la presence de differents plugins Salome
 */
public class TestPresencePlugin {

	/**
	 * Definit la chemin du plugin requirement
	 */
	final static String REQUIREMENT_PLUGIN = "/plugins/requirements/requirements.jnlp";
	final static String ABBOTSCRIPTRUNNER_PLUGIN = "/plugins/abbotScriptRunner/abbotScriptRunner.jar";
	final static String BEANSHELL_PLUGIN = "/plugins/beanshell/beanshell.jar";
	final static String SIMPLEJUNIT_PLUGIN = "/plugins/simpleJunit/simpleJunit.jar";

	/**
     * Fonction qui teste la presence du plugin Requirement
     * @return true or false
     */
	public static boolean testDeLaPresenceDuPluginRequirement(){
		URL _urlBase = SalomeTMFContext.getInstance().getUrlBase();
		String urlTexte = _urlBase.toString();
		urlTexte = urlTexte.substring(0, urlTexte.lastIndexOf("/"));
		String urlATester = urlTexte + REQUIREMENT_PLUGIN;
		// == TBT 2008-03-17
		try {
			java.net.URLConnection conn = (URLConnection) new URL(urlATester).openConnection();
			conn.connect();
			return true;
		}
		catch (SocketTimeoutException e) {
			return false;
		}
		catch (IOException e) {
			return false;
		}
		// TBT 2008-03-17 ==
	}

    /**
     * Fonction qui teste la presence du plugin Abbot
     * @return true or false
     */
	public static boolean testDeLaPresenceDuPluginAbbotScriptRunner(){
		URL _urlBase = SalomeTMFContext.getInstance().getUrlBase();
		String urlTexte = _urlBase.toString();
		urlTexte = urlTexte.substring(0, urlTexte.lastIndexOf("/"));
		String urlATester = urlTexte + ABBOTSCRIPTRUNNER_PLUGIN;
		// == TBT 2008-03-17
		try {
			java.net.URLConnection conn = (URLConnection) new URL(urlATester).openConnection();
			conn.connect();
			return true;
		}
		catch (SocketTimeoutException e) {
			return false;
		}
		catch (IOException e) {
			return false;
		}
		// TBT 2008-03-17 ==
	}

    /**
     * Fonction qui teste la presence du plugin BeanShel
     * @return true or false
     */
	public static boolean testDeLaPresenceDuPluginBeanShell(){
		URL _urlBase = SalomeTMFContext.getInstance().getUrlBase();
		String urlTexte = _urlBase.toString();
		urlTexte = urlTexte.substring(0, urlTexte.lastIndexOf("/"));
		String urlATester = urlTexte + BEANSHELL_PLUGIN;
		// == TBT 2008-03-17
		try {
			java.net.URLConnection conn = (URLConnection) new URL(urlATester).openConnection();
			conn.connect();
			return true;
		}
		catch (SocketTimeoutException e) {
			return false;
		}
		catch (IOException e) {
			return false;
		}
		// TBT 2008-03-17 ==
	}

    /**
     * Fonction qui teste la presence du plugin SimpleJUnit
     * @return true or false
     */
	public static boolean testDeLaPresenceDuPluginSimpleJunit(){
		URL _urlBase = SalomeTMFContext.getInstance().getUrlBase();
		String urlTexte = _urlBase.toString();
		urlTexte = urlTexte.substring(0, urlTexte.lastIndexOf("/"));
		String urlATester = urlTexte + SIMPLEJUNIT_PLUGIN;
		// == TBT 2008-03-17
		try {
			java.net.URLConnection conn = (URLConnection) new URL(urlATester).openConnection();
			conn.connect();
			return true;
		}
		catch (SocketTimeoutException e) {
			return false;
		}
		catch (IOException e) {
			return false;
		}
		// TBT 2008-03-17 ==
	}

}
