package salomeTMF_plug.pluginxlsxml.sqlWrapper;

import java.net.URL;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.Properties;

import org.objectweb.salome_tmf.api.Util;
import org.objectweb.salome_tmf.api.sql.IDataBase;
import org.objectweb.salome_tmf.api.sql.ISQLEngine;
import org.objectweb.salome_tmf.api.sql.ISQLObjectFactory;
import org.objectweb.salome_tmf.ihm.main.SalomeTMFContext;

public class SQLWrapper {

	static Properties comonQuery;

	static IDataBase db;

	static ISQLEngine pISQLEngine = null;

	final static String XLS_XML_SQL_FILE = "/salomeTMF_plug/pluginxlsxml/resources/sql/sqlQuery.properties";

	/**
	 * @param pISQLObjectFactory
	 * @throws Exception
	 */
	public static void init(ISQLObjectFactory pISQLObjectFactory)
			throws Exception {
		URL _urlBase = SalomeTMFContext.getInstance().getUrlBase();
		String url_txt = _urlBase.toString();
		url_txt = url_txt.substring(0, url_txt.lastIndexOf("/"));
		URL urlBase = new URL(url_txt);

		java.net.URL url_cfg = new java.net.URL(urlBase + XLS_XML_SQL_FILE);
		try {
			comonQuery = Util.getPropertiesFile(url_cfg);
		} catch (Exception ex) {
			try {
				comonQuery = Util.getPropertiesFile(XLS_XML_SQL_FILE);
			} catch (Exception ex1) {
				Util.err("", ex1);
			}
		}
		db = pISQLObjectFactory.getInstanceOfSalomeDataBase();
		Util.log("[SQLWrapper->init] database is " + db);
		pISQLEngine = pISQLObjectFactory.getCurrentSQLEngine();
		String SqlLockWrite = comonQuery.getProperty("myLockWrite");
		Util.log("[SQLWrapper->init] Add lock Write " + SqlLockWrite + " to "
				+ pISQLEngine);
		String SqlLockRead = comonQuery.getProperty("myLockRead");
		Util.log("[SQLWrapper->init] Add lock Read " + SqlLockRead + " to "
				+ pISQLEngine);
		// pISQLEngine.addSQLLoackWrite(SqlLockWrite);
		// pISQLEngine.addSQLLoackRead(SqlLockRead);

	}

	/**
	 * @param queryName
	 * @return PreparedStatement
	 * @throws Exception
	 */
	public static PreparedStatement getSQLSelectQuery(String queryName)
			throws Exception {
		System.out.println("->getSQLQuery " + queryName + " : " + comonQuery);
		Util.log("[SQLWrapper->getSQLQuery]" + queryName + " : " + comonQuery);
		String sql = comonQuery.getProperty(queryName);
		Util.log("[SQLWrapper->getSQLQuery] sql is " + sql);
		PreparedStatement prep = db.prepareStatement(sql);
		return prep;
	}

	/**
	 * @param queryName
	 * @return PreparedStatement
	 * @throws Exception
	 */
	public static PreparedStatement getSQLUpdateQuery(String queryName)
			throws Exception {
		Util.log("[SQLWrapper->getSQLDeleteQuery]" + queryName);
		String sql = comonQuery.getProperty(queryName);
		Util.log("[SQLWrapper->getSQLDeleteQuery] sql is " + sql);
		PreparedStatement prep = db.prepareStatement(sql);
		return prep;
	}

	/**
	 * @param prep
	 * @return PreparedStatement
	 * @throws Exception
	 */
	public static synchronized int runUpdateQuery(PreparedStatement prep)
			throws Exception {
		return prep.executeUpdate();
	}

	/**
	 * @param prep
	 * @return PreparedStatement
	 * @throws Exception
	 */
	public static synchronized ResultSet runSelectQuery(PreparedStatement prep)
			throws Exception {
		return prep.executeQuery();
	}

	/**
	 * @return PreparedStatement
	 * @throws Exception
	 */
	static public synchronized int beginTransaction() throws Exception {
		return pISQLEngine.beginTransDB(0, 1000);
	}

	/**
	 * @param id
	 * @throws Exception
	 */
	static synchronized public void commitTrans(int id) throws Exception {
		pISQLEngine.commitTransDB(id);
	}

	/**
	 * @param id
	 * @throws Exception
	 */
	static synchronized public void rollBackTrans(int id) throws Exception {
		pISQLEngine.rollForceBackTransDB(id);
	}

}
